/**
 * generated by Xtext 2.25.0
 */
package tdt4250.xjava;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Compilation Unit</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tdt4250.xjava.CompilationUnit#getPackageDecl <em>Package Decl</em>}</li>
 *   <li>{@link tdt4250.xjava.CompilationUnit#getImports <em>Imports</em>}</li>
 *   <li>{@link tdt4250.xjava.CompilationUnit#getClasses <em>Classes</em>}</li>
 * </ul>
 *
 * @see tdt4250.xjava.XjavaPackage#getCompilationUnit()
 * @model
 * @generated
 */
public interface CompilationUnit extends EObject
{
  /**
   * Returns the value of the '<em><b>Package Decl</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Package Decl</em>' containment reference.
   * @see #setPackageDecl(PackageDeclaration)
   * @see tdt4250.xjava.XjavaPackage#getCompilationUnit_PackageDecl()
   * @model containment="true"
   * @generated
   */
  PackageDeclaration getPackageDecl();

  /**
   * Sets the value of the '{@link tdt4250.xjava.CompilationUnit#getPackageDecl <em>Package Decl</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Package Decl</em>' containment reference.
   * @see #getPackageDecl()
   * @generated
   */
  void setPackageDecl(PackageDeclaration value);

  /**
   * Returns the value of the '<em><b>Imports</b></em>' containment reference list.
   * The list contents are of type {@link tdt4250.xjava.ImportStatement}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Imports</em>' containment reference list.
   * @see tdt4250.xjava.XjavaPackage#getCompilationUnit_Imports()
   * @model containment="true"
   * @generated
   */
  EList<ImportStatement> getImports();

  /**
   * Returns the value of the '<em><b>Classes</b></em>' containment reference list.
   * The list contents are of type {@link tdt4250.xjava.TypeDeclaration}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Classes</em>' containment reference list.
   * @see tdt4250.xjava.XjavaPackage#getCompilationUnit_Classes()
   * @model containment="true"
   * @generated
   */
  EList<TypeDeclaration> getClasses();

} // CompilationUnit
